﻿using System;
using System.ComponentModel.Composition;
using System.Linq;
using System.Windows;
using Ascon.Pilot.SDK.Toolbar;

namespace Ascon.Pilot.SDK.ToolbarSample
{
    [Export(typeof(IToolbar<DocumentFilesContext>))]
    public class DocumentFilesToolbarSample : IToolbar<DocumentFilesContext>
    {
        private const string SHOW_INFO_ITEM_NAME = "miShowInfo";

        public void Build(IToolbarBuilder builder, DocumentFilesContext context)
        {
            if (context.Usage == DocumentFilesUsage.ObjectsExplorer)
            {
                builder.AddButtonItem(SHOW_INFO_ITEM_NAME, builder.Count).WithHeader("Показать информацию");
            }
        }

        public void OnToolbarItemClick(string name, DocumentFilesContext context)
        {
            if (name == SHOW_INFO_ITEM_NAME)
            {
                var info = context.IsMounted
                    ? $"Документ {context.EcmDocument.DisplayName} смонтирован в рабочую папку"
                    : $"Документ {context.EcmDocument.DisplayName} не смонтирован в рабочую папку";
                info += Environment.NewLine + $"Выбрано элементов: {context.SelectedObjects.Count()}";
                foreach (var obj in context.SelectedObjects)
                {
                    info += Environment.NewLine + obj.Path;
                }
                MessageBox.Show(info, "Информация");
            }
        }
    }
}
